diff --git a/web/pgadmin/tools/maintenance/static/js/maintenance.js b/web/pgadmin/tools/maintenance/static/js/maintenance.js
index 6df2d94fd..93dc5ffd9 100644
--- a/web/pgadmin/tools/maintenance/static/js/maintenance.js
+++ b/web/pgadmin/tools/maintenance/static/js/maintenance.js
@@ -166,7 +166,7 @@ define([
         label: gettext('Maintenance...'),
         icon: 'fa fa-wrench',
         enable: supportedNodes.enabled.bind(
-          null, pgBrowser.treeMenu, menuUtils.maintenanceSupportedNodes
+          null, pgBrowser.tree, menuUtils.maintenanceSupportedNodes
         ),
         data: {
           data_disabled: gettext('Please select any database from the browser tree to do Maintenance.'),
@@ -185,7 +185,7 @@ define([
           label: gettext('Maintenance...'),
           icon: 'fa fa-wrench',
           enable: supportedNodes.enabled.bind(
-            null, pgBrowser.treeMenu, menuUtils.maintenanceSupportedNodes
+            null, pgBrowser.tree, menuUtils.maintenanceSupportedNodes
           ),
           data: {
             data_disabled: gettext('Please select any database from the browser tree to do Maintenance.'),
@@ -210,7 +210,7 @@ define([
         }
 
         if (pgBrowser.tree.hasParent(i)) {
-          i = $(pgBrowser.tree.parent(i));
+          i = pgBrowser.tree.parent(i);
         } else {
           Alertify.alert(gettext('Please select server or child node from tree.'));
           break;
@@ -230,13 +230,12 @@ define([
 
       i = item || t.selected();
 
-      var d = i && i.length == 1 ? t.itemData(i) : undefined;
+      var d = i  ? t.itemData(i) : undefined;
 
       if (!d)
         return;
 
-      var node = pgBrowser.Nodes[d._type],
-        treeInfo = node.getTreeNodeHierarchy.apply(node, [i]);
+      var treeInfo = t && t.getTreeNodeHierarchy(i);
 
       if (treeInfo.database._label.indexOf('=') >= 0) {
         Alertify.alert(
@@ -325,7 +324,7 @@ define([
                 if (!itemData)
                   return;
 
-                var node_hierarchy = sel_node.getTreeNodeHierarchy.apply(sel_node, [sel_item]);
+                var node_hierarchy = pgBrowser.tree.getTreeNodeHierarchy.apply(sel_item);
 
                 if (node_hierarchy.schema != undefined) {
                   schema = node_hierarchy.schema._label;
@@ -415,7 +414,7 @@ define([
               if (!itemInfo)
                 return;
 
-              var treeData = nodeData.getTreeNodeHierarchy.apply(nodeData, [sel_item]);
+              var treeData = tree.getTreeNodeHierarchy.apply(nodeData, [sel_item]);
 
               var newModel = new MaintenanceModel({}, {
                   node_info: treeData,
diff --git a/web/pgadmin/tools/psql/static/js/psql_module.js b/web/pgadmin/tools/psql/static/js/psql_module.js
index 94a66ec57..8feb15cd4 100644
--- a/web/pgadmin/tools/psql/static/js/psql_module.js
+++ b/web/pgadmin/tools/psql/static/js/psql_module.js
@@ -18,7 +18,6 @@ import {getRandomInt, hasBinariesConfiguration, registerDetachEvent} from 'sourc
 import {retrieveAncestorOfTypeServer} from 'sources/tree/tree_utils';
 import pgWindow from 'sources/window';
 
-import {getTreeNodeHierarchyFromIdentifier} from 'sources/tree/pgadmin_tree_node';
 import {generateTitle, refresh_db_node} from 'tools/datagrid/static/js/datagrid_panel_title';
 
 
@@ -120,7 +119,7 @@ export function initialize(gettext, url_for, $, _, pgAdmin, csrfToken, Browser)
         return;
       }
 
-      const node = pgBrowser.treeMenu.findNodeByDomElement(aciTreeIdentifier);
+      const node = pgBrowser.tree.findNodeByDomElement(aciTreeIdentifier);
       if (node === undefined || !node.getData()) {
         Alertify.alert(
           gettext('PSQL Error'),
@@ -129,10 +128,7 @@ export function initialize(gettext, url_for, $, _, pgAdmin, csrfToken, Browser)
         return;
       }
 
-      parentData = getTreeNodeHierarchyFromIdentifier.call(
-        pgBrowser,
-        aciTreeIdentifier
-      );
+      parentData = pgBrowser.tree.translateTreeNodeIdFromReactTree(aciTreeIdentifier);
 
       if(_.isUndefined(parentData.server)) {
         Alertify.alert(
@@ -366,9 +362,9 @@ export function initialize(gettext, url_for, $, _, pgAdmin, csrfToken, Browser)
     check_db_name_change: function(db_name, o_db_name) {
       if (db_name != o_db_name) {
 
-        var selected_item = pgWindow.pgAdmin.Browser.treeMenu.selected(),
-          tree_data = pgWindow.pgAdmin.Browser.treeMenu.translateTreeNodeIdFromACITree(selected_item),
-          database_data = pgWindow.pgAdmin.Browser.treeMenu.findNode(tree_data.slice(0,4)),
+        var selected_item = pgWindow.pgAdmin.Browser.tree.selected(),
+          tree_data = pgWindow.pgAdmin.Browser.tree.translateTreeNodeIdFromReactTree(selected_item),
+          database_data = pgWindow.pgAdmin.Browser.tree.findNode(tree_data[3]),
           dbNode = database_data.domNode;
 
         var message = `Current database has been moved or renamed to ${o_db_name}. Click on the OK button to refresh the database name, and reopen the psql again.`;
diff --git a/web/pgadmin/tools/restore/static/js/restore.js b/web/pgadmin/tools/restore/static/js/restore.js
index b0d43f9e5..50bd63dc5 100644
--- a/web/pgadmin/tools/restore/static/js/restore.js
+++ b/web/pgadmin/tools/restore/static/js/restore.js
@@ -271,8 +271,8 @@ define('tools.restore', [
         visible: function() {
           var t = pgBrowser.tree,
             i = t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined,
-            s = _.isUndefined(d) ? undefined : pgBrowser.Nodes[d._type].getTreeNodeHierarchy(i)['server'];
+            d = i  ? t.itemData(i) : undefined,
+            s = _.isUndefined(d) ? undefined : pgBrowser.tree.getTreeNodeHierarchy(i)['server'];
 
           return _.isUndefined(s) ? false : s.version >= 110000;
         },
@@ -396,7 +396,7 @@ define('tools.restore', [
         label: gettext('Restore...'),
         icon: 'fa fa-upload',
         enable: supportedNodes.enabled.bind(
-          null, pgBrowser.treeMenu, menuUtils.restoreSupportedNodes
+          null, pgBrowser.tree, menuUtils.restoreSupportedNodes
         ),
         data: {
           data_disabled: gettext('Please select any schema or table from the browser tree to Restore data.'),
@@ -414,7 +414,7 @@ define('tools.restore', [
           label: gettext('Restore...'),
           icon: 'fa fa-upload',
           enable: supportedNodes.enabled.bind(
-            null, pgBrowser.treeMenu, menuUtils.restoreSupportedNodes
+            null, pgBrowser.tree, menuUtils.restoreSupportedNodes
           ),
         });
       }
diff --git a/web/pgadmin/tools/restore/static/js/restore_dialog.js b/web/pgadmin/tools/restore/static/js/restore_dialog.js
index 20a22aa8d..f2e95caec 100644
--- a/web/pgadmin/tools/restore/static/js/restore_dialog.js
+++ b/web/pgadmin/tools/restore/static/js/restore_dialog.js
@@ -57,8 +57,8 @@ export class RestoreDialog extends Dialog {
         return;
       }
 
-      let aciTreeItem1 = aciTreeItem || that.pgBrowser.treeMenu.selected();
-      let item = that.pgBrowser.treeMenu.findNodeByDomElement(aciTreeItem1);
+      let aciTreeItem1 = aciTreeItem || that.pgBrowser.tree.selected();
+      let item = that.pgBrowser.tree.findNodeByDomElement(aciTreeItem1);
       const data = item.getData();
       const node = that.pgBrowser.Nodes[data._type];
 
diff --git a/web/pgadmin/tools/restore/static/js/restore_dialog_wrapper.js b/web/pgadmin/tools/restore/static/js/restore_dialog_wrapper.js
index c9cda5d66..ee57cb2f9 100644
--- a/web/pgadmin/tools/restore/static/js/restore_dialog_wrapper.js
+++ b/web/pgadmin/tools/restore/static/js/restore_dialog_wrapper.js
@@ -7,7 +7,6 @@
 //
 //////////////////////////////////////////////////////////////
 
-import {getTreeNodeHierarchyFromElement} from '../../../../static/js/tree/pgadmin_tree_node';
 import axios from 'axios/index';
 import _ from 'underscore';
 import gettext from '../../../../static/js/gettext';
@@ -93,8 +92,7 @@ export class RestoreDialogWrapper extends DialogWrapper {
     }
 
     const node = this.pgBrowser.Nodes[selectedTreeNodeData._type];
-
-    const treeInfo = getTreeNodeHierarchyFromElement(this.pgBrowser, selectedTreeNode);
+    const treeInfo = this.pgBrowser.tree.getTreeNodeHierarchy(selectedTreeNode);
     const dialog = this.createDialog(node, treeInfo, $container);
     this.addAlertifyClassToRestoreNodeChildNodes();
     dialog.render();
@@ -149,10 +147,7 @@ export class RestoreDialogWrapper extends DialogWrapper {
         'sid': serverIdentifier,
       });
 
-      const treeInfo = getTreeNodeHierarchyFromElement(
-        this.pgBrowser,
-        selectedTreeNode
-      );
+      const treeInfo = this.pgBrowser.tree.getTreeNodeHierarchy(selectedTreeNode);
 
       this.setExtraParameters(selectedTreeNode, treeInfo);
 
@@ -190,7 +185,7 @@ export class RestoreDialogWrapper extends DialogWrapper {
   }
 
   getSelectedNode() {
-    const tree = this.pgBrowser.treeMenu;
+    const tree = this.pgBrowser.tree;
     const selectedNode = tree.selected();
     if (selectedNode) {
       return tree.findNodeByDomElement(selectedNode);
@@ -225,10 +220,7 @@ export class RestoreDialogWrapper extends DialogWrapper {
   }
 
   retrieveServerIdentifier(node, selectedTreeNode) {
-    const treeInfo = getTreeNodeHierarchyFromElement(
-      this.pgBrowser,
-      selectedTreeNode
-    );
+    const treeInfo = this.pgBrowser.tree.getTreeNodeHierarchy(selectedTreeNode);
     return treeInfo.server._id;
   }
 
diff --git a/web/pgadmin/tools/search_objects/static/js/search_objects_dialog_wrapper.js b/web/pgadmin/tools/search_objects/static/js/search_objects_dialog_wrapper.js
index 2bec153d2..62d37edc1 100644
--- a/web/pgadmin/tools/search_objects/static/js/search_objects_dialog_wrapper.js
+++ b/web/pgadmin/tools/search_objects/static/js/search_objects_dialog_wrapper.js
@@ -1,4 +1,12 @@
-import {getTreeNodeHierarchyFromElement} from 'sources/tree/pgadmin_tree_node';
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2021, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
 import axios from 'axios/index';
 import gettext from 'sources/gettext';
 import url_for from 'sources/url_for';
@@ -261,7 +269,7 @@ export default class SearchObjectsDialogWrapper extends DialogWrapper {
 
     this.grid.onDblClick.subscribe((event, args) => {
       let rowData = this.dataview.getItem(args.row);
-      let treeMenu = this.pgBrowser.treeMenu;
+      let tree = this.pgBrowser.tree;
 
       if(!rowData.show_node) {
         this.showMessage(
@@ -278,9 +286,9 @@ export default class SearchObjectsDialogWrapper extends DialogWrapper {
         return false;
       }
       this.showMessage(gettext('Locating...'));
-      treeMenu.findNodeWithToggle(rowData.id_path)
+      tree.findNodeWithToggle(rowData.id_path)
         .then((treeItem)=>{
-          treeMenu.selectNode(treeItem.domNode, true);
+          tree.select(treeItem, true);
           this.showMessage(null);
         })
         .catch((error)=>{
@@ -349,7 +357,7 @@ export default class SearchObjectsDialogWrapper extends DialogWrapper {
   }
 
   getSelectedNode() {
-    const tree = this.pgBrowser.treeMenu;
+    const tree = this.pgBrowser.tree;
     const selectedNode = tree.selected();
     if (selectedNode) {
       return tree.findNodeByDomElement(selectedNode);
@@ -404,7 +412,7 @@ export default class SearchObjectsDialogWrapper extends DialogWrapper {
     let id_path = [
       this.treeInfo.server_group.id,
       this.treeInfo.server.id,
-      this.getCollNode('database').type + '/' + this.treeInfo.server._id,
+      this.getCollNode('database').type + '_' + this.treeInfo.server._id,
       this.treeInfo.database.id,
     ];
 
@@ -435,10 +443,10 @@ export default class SearchObjectsDialogWrapper extends DialogWrapper {
       let coll_node = this.getCollNode(node_type);
       if(coll_node) {
         /* Add coll node to the path */
-        if(prev_node_id != null) id_path.push(`${coll_node.type}/${prev_node_id}`);
+        if(prev_node_id != null) id_path.push(`${coll_node.type}_${prev_node_id}`);
 
         /* Add the node to the path */
-        id_path.push(`${node_type}/${node_oid}`);
+        id_path.push(`${node_type}_${node_oid}`);
 
         /* This will be needed for coll node */
         prev_node_id = node_oid;
@@ -447,7 +455,7 @@ export default class SearchObjectsDialogWrapper extends DialogWrapper {
         return  `/${coll_node.label}/`;
       } else if(node_type in this.pgBrowser.Nodes) {
         /* Add the node to the path */
-        id_path.push(`${node_type}/${node_oid}`);
+        id_path.push(`${node_type}_${node_oid}`);
 
         /* This will be need for coll node id path */
         prev_node_id = node_oid;
@@ -652,7 +660,7 @@ export default class SearchObjectsDialogWrapper extends DialogWrapper {
       return;
     }
 
-    this.treeInfo = getTreeNodeHierarchyFromElement(this.pgBrowser, selectedTreeNode);
+    this.treeInfo = this.pgBrowser.tree.getTreeNodeHierarchy(selectedTreeNode);
     this.prepareDialog();
     this.focusOnDialog(this);
   }
diff --git a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
index f221161eb..a641ecba8 100644
--- a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
+++ b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
@@ -2720,26 +2720,20 @@ define('tools.querytool', [
 
           $('#btn-conn-status i').removeClass('obtaining-conn');
 
-          var tree_data = pgWindow.default.pgAdmin.Browser.treeMenu.translateTreeNodeIdFromACITree(pgWindow.default.pgAdmin.Browser.treeMenu.selected());
-
-          var server_data = pgWindow.default.pgAdmin.Browser.treeMenu.findNode(tree_data.slice(0,2));
-          var database_data = pgWindow.default.pgAdmin.Browser.treeMenu.findNode(tree_data.slice(0,4));
-          var dbData = tree_data.slice(0,3);
-          dbData.push('database/' + url_params.did);
-          var dbName = pgWindow.default.pgAdmin.Browser.treeMenu.findNode(dbData).data.label;
-          let conn_title = panelTitleFunc.getPanelTitle(pgWindow.default.pgAdmin.Browser, null, null, null, true, dbName);
+          var tree_data = pgWindow.default.pgAdmin.Browser.tree.getTreeNodeHierarchy(pgWindow.default.pgAdmin.Browser.tree.selected());
+          let conn_title = panelTitleFunc.getPanelTitle(pgWindow.default.pgAdmin.Browser, null, null, null, true, tree_data.database.label);
           self.gridView.set_editor_title(_.unescape(conn_title));
           let connection_data = {
             'server_group': self.gridView.handler.url_params.sgid,
             'server': self.gridView.handler.url_params.sid,
             'database': self.gridView.handler.url_params.did,
-            'user': server_data.data.user.name,
+            'user': tree_data.server.user.name,
             'role': null,
             'title': _.unescape(url_params.title),
             'conn_title': _.unescape(conn_title),
             'is_allow_new_connection': false,
-            'database_name': _.unescape(database_data.data.label),
-            'server_name': _.unescape(server_data.data.label),
+            'database_name': _.unescape(tree_data.database.label),
+            'server_name': _.unescape(tree_data.server.label),
             'is_selected': true,
           };
           delete connection_data.password;
@@ -5171,10 +5165,10 @@ define('tools.querytool', [
 
         var self = this;
 
-        var selected_item = pgWindow.default.pgAdmin.Browser.treeMenu.selected(),
-          tree_data = pgWindow.default.pgAdmin.Browser.treeMenu.translateTreeNodeIdFromACITree(selected_item),
-          server_data = pgWindow.default.pgAdmin.Browser.treeMenu.findNode(tree_data.slice(0,2)),
-          database_data = pgWindow.default.pgAdmin.Browser.treeMenu.findNode(tree_data.slice(0,4)),
+        var selected_item = pgWindow.default.pgAdmin.Browser.tree.selected(),
+          tree_data = pgWindow.default.pgAdmin.Browser.tree.translateTreeNodeIdFromReactTree(selected_item),
+          server_data = pgWindow.default.pgAdmin.Browser.tree.findNode(tree_data[1]),
+          database_data = pgWindow.default.pgAdmin.Browser.tree.findNode(tree_data[3]),
           db_name = database_data.data.label,
           db_did = database_data.data._id;
 
diff --git a/web/regression/javascript/backup/backup_dialog_spec.js b/web/regression/javascript/backup/backup_dialog_spec.js
index 8793e0976..2ac646760 100644
--- a/web/regression/javascript/backup/backup_dialog_spec.js
+++ b/web/regression/javascript/backup/backup_dialog_spec.js
@@ -22,7 +22,6 @@ describe('BackupDialog', () => {
 
   beforeEach(() => {
     pgBrowser = {
-      treeMenu: new TreeFake(),
       Nodes: {
         server: {
           hasId: true,
@@ -53,6 +52,7 @@ describe('BackupDialog', () => {
         default: 550,
       },
     };
+    pgBrowser.tree = new TreeFake(pgBrowser);
     pgBrowser.Nodes.server.hasId = true;
     pgBrowser.Nodes.database.hasId = true;
     jquerySpy = jasmine.createSpy('jquerySpy');
@@ -126,7 +126,7 @@ describe('BackupDialog', () => {
       ],
     };
 
-    pgBrowser.treeMenu = TreeFake.build(hierarchy);
+    pgBrowser.tree = TreeFake.build(hierarchy, pgBrowser);
   });
 
   describe('#draw', () => {
@@ -151,7 +151,7 @@ describe('BackupDialog', () => {
 
     context('there are no ancestors of the type server', () => {
       it('does not create a dialog', () => {
-        pgBrowser.treeMenu.selectNode([{id: 'root'}]);
+        pgBrowser.tree.selectNode([{id: 'root'}]);
         backupDialog.draw(null, null, null);
         expect(alertifySpy['backup_objects']).not.toHaveBeenCalled();
       });
diff --git a/web/regression/javascript/backup/backup_dialog_wrapper_spec.js b/web/regression/javascript/backup/backup_dialog_wrapper_spec.js
index 1fcb44c04..e3c91ecea 100644
--- a/web/regression/javascript/backup/backup_dialog_wrapper_spec.js
+++ b/web/regression/javascript/backup/backup_dialog_wrapper_spec.js
@@ -12,7 +12,7 @@ import {BackupDialogWrapper} from '../../../pgadmin/tools/backup/static/js/backu
 import axios from 'axios/index';
 import MockAdapter from 'axios-mock-adapter';
 import {FakeModel} from '../fake_model';
-import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree_nodes';
 
 let context = describe;
 
@@ -34,7 +34,6 @@ describe('BackupDialogWrapper', () => {
 
   beforeEach(() => {
     pgBrowser = {
-      treeMenu: new TreeFake(),
       Nodes: {
         server: {
           hasId: true,
@@ -47,8 +46,10 @@ describe('BackupDialogWrapper', () => {
       keyboardNavigation: jasmine.createSpyObj('keyboardNavigation', ['getDialogTabNavigator']),
     };
 
-    noDataNode = pgBrowser.treeMenu.addNewNode('level1.1', undefined, [{id: 'level1'}]);
-    serverTreeNode = pgBrowser.treeMenu.addNewNode('level2.1', {
+    pgBrowser.tree = new TreeFake(pgBrowser);
+
+    noDataNode = pgBrowser.tree.addNewNode('level1.1', undefined, [{id: 'level1'}]);
+    serverTreeNode = pgBrowser.tree.addNewNode('level2.1', {
       _type: 'server',
       _id: 10,
       label: 'some-tree-label',
@@ -57,7 +58,7 @@ describe('BackupDialogWrapper', () => {
       _type: 'database',
       _label: 'some-database-label',
     }, [{id: 'database-tree-node'}]);
-    pgBrowser.treeMenu.addChild(serverTreeNode, databaseTreeNode);
+    pgBrowser.tree.addChild(serverTreeNode, databaseTreeNode);
 
     jquerySpy = jasmine.createSpy('jquerySpy');
     backupNode = {
@@ -132,7 +133,7 @@ describe('BackupDialogWrapper', () => {
 
     context('selected tree node has no data', () => {
       beforeEach(() => {
-        pgBrowser.treeMenu.selectNode(noDataNode.domNode);
+        pgBrowser.tree.selectNode(noDataNode.domNode);
       });
 
       it('does not create a backform dialog', () => {
@@ -159,7 +160,7 @@ describe('BackupDialogWrapper', () => {
             label: 'some-tree-label',
           },
         };
-        pgBrowser.treeMenu.selectNode(serverTreeNode.domNode);
+        pgBrowser.tree.selectNode(serverTreeNode.domNode);
         pgBrowser.Nodes['server'].getTreeNodeHierarchy.and
           .returnValue(treeHierarchyInformation);
         dialogSpy = jasmine.createSpyObj('newView', ['render']);
@@ -238,7 +239,7 @@ describe('BackupDialogWrapper', () => {
           networkCalled = true;
           return [200, {}];
         });
-        pgBrowser.treeMenu.selectNode(serverTreeNode.domNode);
+        pgBrowser.tree.selectNode(serverTreeNode.domNode);
         pgBrowser.showHelp = jasmine.createSpy('showHelp');
 
         const event = {
@@ -278,7 +279,7 @@ describe('BackupDialogWrapper', () => {
           networkCalled = true;
           return [200, {}];
         });
-        pgBrowser.treeMenu.selectNode(serverTreeNode.domNode);
+        pgBrowser.tree.selectNode(serverTreeNode.domNode);
         pgBrowser.showHelp = jasmine.createSpy('showHelp');
 
         const event = {
@@ -337,7 +338,7 @@ describe('BackupDialogWrapper', () => {
 
       context('tree node has no data', () => {
         it('does not start the backup', () => {
-          pgBrowser.treeMenu.selectNode(noDataNode.domNode);
+          pgBrowser.tree.selectNode(noDataNode.domNode);
 
           let networkCalled = false;
           networkMock.onAny(/.*/).reply(() => {
@@ -365,7 +366,7 @@ describe('BackupDialogWrapper', () => {
         context('when dialog type is global', () => {
           let event;
           beforeEach(() => {
-            pgBrowser.treeMenu.selectNode(serverTreeNode.domNode);
+            pgBrowser.tree.selectNode(serverTreeNode.domNode);
 
             backupDialogWrapper.view = {
               model: new FakeModel(),
@@ -465,7 +466,7 @@ describe('BackupDialogWrapper', () => {
               backform
             );
 
-            pgBrowser.treeMenu.selectNode(databaseTreeNode.domNode);
+            pgBrowser.tree.selectNode(databaseTreeNode.domNode);
 
             backupDialogWrapper.view = {
               model: new FakeModel(),
diff --git a/web/regression/javascript/backup/global_server_backup_dialog_spec.js b/web/regression/javascript/backup/global_server_backup_dialog_spec.js
index 8497e7a71..b16dfa33e 100644
--- a/web/regression/javascript/backup/global_server_backup_dialog_spec.js
+++ b/web/regression/javascript/backup/global_server_backup_dialog_spec.js
@@ -26,7 +26,6 @@ describe('GlobalServerBackupDialog', () => {
 
   beforeEach(() => {
     pgBrowser = {
-      treeMenu: new TreeFake(),
       Nodes: {
         server: jasmine.createSpyObj('Node[server]', ['getTreeNodeHierarchy']),
       },
@@ -43,35 +42,36 @@ describe('GlobalServerBackupDialog', () => {
         default: 550,
       },
     };
+    pgBrowser.tree = new TreeFake(pgBrowser);
     pgBrowser.Nodes.server.hasId = true;
     jquerySpy = jasmine.createSpy('jquerySpy');
     backupModelSpy = jasmine.createSpy('backupModelSpy');
 
-    rootNode = pgBrowser.treeMenu.addNewNode('level1', {}, undefined, []);
-    serverTreeNode = pgBrowser.treeMenu.addNewNode('level1.1', {
+    rootNode = pgBrowser.tree.addNewNode('level1', {}, undefined, []);
+    serverTreeNode = pgBrowser.tree.addNewNode('level1.1', {
       _type: 'server',
       _id: 10,
       server_type: 'pg',
       version: 100000,
     }, undefined, ['level1']);
-    serverTreeNodeWrongPath = pgBrowser.treeMenu.addNewNode('level1.2', {
+    serverTreeNodeWrongPath = pgBrowser.tree.addNewNode('level1.2', {
       _type: 'server',
       _id: 11,
       server_type: 'pg',
       version: 90600,
     }, undefined, ['level1']);
-    ppasServerTreeNode = pgBrowser.treeMenu.addNewNode('level1.3', {
+    ppasServerTreeNode = pgBrowser.tree.addNewNode('level1.3', {
       _type: 'server',
       server_type: 'ppas',
       version: 130000,
     }, undefined, ['level1']);
-    ppasServerTreeNodeWrongPath = pgBrowser.treeMenu.addNewNode('level1.4', {
+    ppasServerTreeNodeWrongPath = pgBrowser.tree.addNewNode('level1.4', {
       _type: 'server',
       server_type: 'ppas',
       version: 90600,
     }, undefined, ['level1']);
-    pgBrowser.treeMenu.addNewNode('level3', {}, undefined, ['level1', 'level1.2', 'level1.3', 'level1.4']);
-    pgBrowser.treeMenu.addNewNode('level3.1', undefined, undefined, ['level1', 'level1.2', 'level3']);
+    pgBrowser.tree.addNewNode('level3', {}, undefined, ['level1', 'level1.2', 'level1.3', 'level1.4']);
+    pgBrowser.tree.addNewNode('level3.1', undefined, undefined, ['level1', 'level1.2', 'level3']);
   });
 
   describe('#draw', () => {
@@ -97,7 +97,7 @@ describe('GlobalServerBackupDialog', () => {
 
     context('there are no ancestors of the type server', () => {
       it('does not create a dialog', () => {
-        pgBrowser.treeMenu.selectNode([{id: 'level1'}]);
+        pgBrowser.tree.selectNode([{id: 'level1'}]);
         backupDialog.draw(null, null, null);
         expect(alertifySpy['BackupDialog_globals']).not.toHaveBeenCalled();
         expect(alertifySpy['BackupDialog_server']).not.toHaveBeenCalled();
diff --git a/web/regression/javascript/datagrid/get_panel_title_spec.js b/web/regression/javascript/datagrid/get_panel_title_spec.js
index 28d2a4609..ed295be11 100644
--- a/web/regression/javascript/datagrid/get_panel_title_spec.js
+++ b/web/regression/javascript/datagrid/get_panel_title_spec.js
@@ -9,7 +9,7 @@
 
 import {getPanelTitle} from '../../../pgadmin/tools/datagrid/static/js/datagrid_panel_title';
 import {TreeFake} from '../tree/tree_fake';
-import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree_nodes';
 import {pgBrowser} from 'pgadmin.browser.preferences';
 
 const context = describe;
@@ -28,7 +28,6 @@ describe('#getPanelTitle', () => {
   let tree;
   beforeEach(() => {
     pgBrowser.preferences_cache = dummy_cache;
-    tree = new TreeFake();
     pgBrowser.Nodes = {
       server: {
         hasId: true,
@@ -39,10 +38,11 @@ describe('#getPanelTitle', () => {
         _type: 'database',
       },
     };
-    pgBrowser.treeMenu = tree;
     pgBrowser.preferences = {
       'qt_tab_title_placeholder': '',
     };
+    tree = new TreeFake(pgBrowser);
+    pgBrowser.tree = tree;
   });
 
   context('selected node does not belong to a server', () => {
diff --git a/web/regression/javascript/datagrid/show_data_spec.js b/web/regression/javascript/datagrid/show_data_spec.js
index a5c5e9323..13cd96c56 100644
--- a/web/regression/javascript/datagrid/show_data_spec.js
+++ b/web/regression/javascript/datagrid/show_data_spec.js
@@ -9,7 +9,7 @@
 
 import {showDataGrid} from '../../../pgadmin/tools/datagrid/static/js/show_data';
 import {TreeFake} from '../tree/tree_fake';
-import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree_nodes';
 import {pgBrowser} from 'pgadmin.browser.preferences';
 
 const context = describe;
@@ -34,7 +34,6 @@ describe('#show_data', () => {
     datagrid = {
       launch_grid: jasmine.createSpy('launch_grid'),
     };
-    pgBrowser.treeMenu = new TreeFake();
     pgBrowser.Nodes = {
       server_group: {
         _type: 'server_group',
@@ -61,12 +60,13 @@ describe('#show_data', () => {
         hasId: true,
       },
     };
-    const parent = pgBrowser.treeMenu.addNewNode('parent', {_type: 'parent'}, []);
+    pgBrowser.tree = new TreeFake(pgBrowser);
+    const parent = pgBrowser.tree.addNewNode('parent', {_type: 'parent'}, []);
     const serverGroup1 = new TreeNode('server_group1', {
       _type: 'server_group',
       _id: 1,
     });
-    pgBrowser.treeMenu.addChild(parent, serverGroup1);
+    pgBrowser.tree.addChild(parent, serverGroup1);
 
     const server1 = new TreeNode('server1', {
       _type: 'server',
@@ -75,35 +75,35 @@ describe('#show_data', () => {
       _id: 2,
       user: {name: 'someuser'},
     }, ['parent', 'server_group1']);
-    pgBrowser.treeMenu.addChild(serverGroup1, server1);
+    pgBrowser.tree.addChild(serverGroup1, server1);
 
     const database1 = new TreeNode('database1', {
       _type: 'database',
       label: 'database1',
       _id: 3,
     }, ['parent', 'server_group1', 'server1']);
-    pgBrowser.treeMenu.addChild(server1, database1);
+    pgBrowser.tree.addChild(server1, database1);
 
     const schema1 = new TreeNode('schema1', {
       _type: 'schema',
       label: 'schema1',
       _id: 4,
     });
-    pgBrowser.treeMenu.addChild(database1, schema1);
+    pgBrowser.tree.addChild(database1, schema1);
 
     const view1 = new TreeNode('view1', {
       _type: 'view',
       label: 'view1',
       _id: 5,
     }, ['parent', 'server_group1', 'server1', 'database1']);
-    pgBrowser.treeMenu.addChild(database1, view1);
+    pgBrowser.tree.addChild(database1, view1);
 
     const catalog1 = new TreeNode('catalog1', {
       _type: 'catalog',
       label: 'catalog1',
       _id: 6,
     }, ['parent', 'server_group1', 'server1', 'database1']);
-    pgBrowser.treeMenu.addChild(database1, catalog1);
+    pgBrowser.tree.addChild(database1, catalog1);
   });
 
   context('cannot find the tree node', () => {
diff --git a/web/regression/javascript/datagrid/show_query_tool_spec.js b/web/regression/javascript/datagrid/show_query_tool_spec.js
index 33f6b00f8..8938bb00e 100644
--- a/web/regression/javascript/datagrid/show_query_tool_spec.js
+++ b/web/regression/javascript/datagrid/show_query_tool_spec.js
@@ -9,7 +9,7 @@
 
 import {TreeFake} from '../tree/tree_fake';
 import {showQueryTool} from '../../../pgadmin/tools/datagrid/static/js/show_query_tool';
-import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree_nodes';
 import {pgBrowser} from 'pgadmin.browser.preferences';
 
 const context = describe;
@@ -34,7 +34,6 @@ describe('#showQueryTool', () => {
     queryTool = {
       launch_grid: jasmine.createSpy('launch_grid'),
     };
-    pgBrowser.treeMenu = new TreeFake();
     pgBrowser.Nodes = {
       server_group: {
         _type: 'server_group',
@@ -49,13 +48,14 @@ describe('#showQueryTool', () => {
         hasId: true,
       },
     };
+    pgBrowser.tree = new TreeFake(pgBrowser);
 
-    const parent = pgBrowser.treeMenu.addNewNode('parent', {_type: 'parent'});
+    const parent = pgBrowser.tree.addNewNode('parent', {_type: 'parent'});
     const serverGroup1 =  new TreeNode('server_group1', {
       _type: 'server_group',
       _id: 1,
     }, ['parent']);
-    pgBrowser.treeMenu.addChild(parent, serverGroup1);
+    pgBrowser.tree.addChild(parent, serverGroup1);
 
     const server1 = new TreeNode('server1', {
       _type: 'server',
@@ -65,14 +65,14 @@ describe('#showQueryTool', () => {
       user: {name: 'someuser'},
       db: 'otherdblabel',
     });
-    pgBrowser.treeMenu.addChild(serverGroup1, server1);
+    pgBrowser.tree.addChild(serverGroup1, server1);
 
     const database1 = new  TreeNode('database1', {
       _type: 'database',
       label: 'database1',
       _id: 3,
     });
-    pgBrowser.treeMenu.addChild(server1, database1);
+    pgBrowser.tree.addChild(server1, database1);
   });
 
   context('cannot find the tree node', () => {
